#include "cbsync.h"

#ifdef _WIN32
/////////////////////////////////////////////////////////////////////
// class CbCriticalSection
//

#include <windows.h>



struct CbCriticalSection::CbCriticalSectionImpl 
{
	CRITICAL_SECTION cs;
};

CbCriticalSection::CbCriticalSection()
{
	_impl = new CbCriticalSectionImpl;
	InitializeCriticalSection(&_impl->cs);
}

CbCriticalSection::~CbCriticalSection()
{
	DeleteCriticalSection(&_impl->cs);
	delete _impl;
}

void CbCriticalSection::Enter()
{
	EnterCriticalSection(&_impl->cs);
}

void CbCriticalSection::Leave()
{
	LeaveCriticalSection(&_impl->cs);
}
#else

#include <pthread.h>

struct CbCriticalSection::CbCriticalSectionImpl
{
		pthread_mutex_t _lock;
};

#include <pthread.h>
# define PTHREAD_RECURSIVE_MUTEX_INITIALIZER_NP   {0, 0, 0, PTHREAD_MUTEX_RECURSIVE_NP, __LOCK_INITIALIZER}

CbCriticalSection::CbCriticalSection()
{
	_impl = new CbCriticalSectionImpl;
	pthread_mutex_t init = PTHREAD_RECURSIVE_MUTEX_INITIALIZER_NP;
	_impl->_lock = init;
}

CbCriticalSection::~CbCriticalSection()
{
    pthread_mutex_destroy(&_impl->_lock);
	delete _impl;
}

void CbCriticalSection::Enter()
{
 	int nRet = pthread_mutex_lock(&_impl->_lock);
 
}

void CbCriticalSection::Leave()
{
 	int nRet = pthread_mutex_unlock(&_impl->_lock);
   
}


#endif
