/*
CHANNEL 1...N
*/
/////////////////////////////////////////
//

#ifdef _WIN32
#include <windows.h>
#else
#include <unistd.h>
#endif
//_---------------------

#include "sharedmem.h"



void CbSleep( unsigned int x )
{
#ifdef _WIN32
	Sleep( x );
#else
	timespec sleeptime, rem;
	sleeptime.tv_sec = x / 1000;
	sleeptime.tv_nsec = 1000*(x % 1000);
	nanosleep( &sleeptime, 0 );
#endif
}



#include <map>
using namespace std;

extern void * GetSharedMem( int offset );

CChannel *GetChannel( int id )
{
	return (CChannel *)GetSharedMem( id );
}

Channel::Channel( int id ) 
{
	_channel = GetChannel( id );
}

Channel::~Channel( ) 
{
}

void Channel::SetState( int state ) 
{
	_channel->state = state;
}
void Channel::SetDATA( const char *str, unsigned int len )
{
	memcpy( _channel->data, str, len );      
}

void Channel::SetLength( int len )  
{
	_channel->length = len;
}

char *Channel::GetDATA( ) 
{
  return _channel->data;      
}

int Channel::GetState( ) 
{
  return _channel->state;
}

int Channel::GetLength() 
{
	return _channel->length;
}

bool Channel::WaitForState( int STATE, unsigned int, unsigned int delay /* = -1 dummy timeout */ ) 
{
	int state = GetState();
	while( state != STATE ) {
		CbSleep( delay );
		state = GetState();
	}
	return true;
}

