#ifndef IpcbaseH
#define IpcbaseH

#include <string>
using std::string;


/*
CHANNEL 1...N
*/
/////////////////////////////////////////
//

enum CHANNEL_STATE {
	UNUSED = 0, // initial state (ready for new aquirement
	ACQUIRED,
	CL_WRITE_DONE,
	SRV_READ_DONE,
	SRV_WRITE_DONE,
	CL_READ_DONE,
	FINISHED,
};


struct CChannel {
	int state;
	int length;
	char data[ 16376 ];
};
/////////////////////////////////////////
class Channel {
  public: 
    Channel( int id );
    virtual ~Channel( );
    //---  
    void SetState( int state );
    void SetDATA( const char *str, unsigned int len );
    void SetLength( int len );

    char *GetDATA( );
    int GetState( );
    int GetLength( );

	bool WaitForState( int STATE, unsigned int = -1, unsigned int delay = 1 /* dummy timeout */ );

  protected:
    CChannel *_channel;
};

bool ReadFromChannel( Channel& ch, string& req );
bool WriteToChannel( Channel& ch, const string& req );

/////////////////////////////////////////

#endif